SystemOrganization addCategory: #'Mongo-Squeak'!

!TimeStamp methodsFor: '*mongo-squeak' stamp: 'NorbertHartl 2/13/2012 17:11'!
bsonTypeCode
	^17! !

!TimeStamp methodsFor: '*mongo-squeak' stamp: 'NorbertHartl 2/13/2012 17:17'!
writeBSONOn: aBSON 
	aBSON nextTimestampPut: self! !

!DateAndTime methodsFor: '*Mongo-Squeak' stamp: 'NorbertHartl 2/13/2012 17:11'!
bsonTypeCode
	^9! !

!DateAndTime methodsFor: '*Mongo-Squeak' stamp: 'NorbertHartl 2/13/2012 17:18'!
writeBSONOn: aBSON 
	aBSON nextDateAndTimePut: self! !

!Float methodsFor: '*Mongo-Squeak' stamp: 'KentBeck 2/11/2010 18:00'!
writeBSONOn: aBSON 
	aBSON nextDoublePut: self! !

Object subclass: #GratuitousIncompatibilities
	instanceVariableNames: ''
	classVariableNames: 'UTF8Codec'
	poolDictionaries: ''
	category: 'Mongo-Squeak'!

!GratuitousIncompatibilities class methodsFor: 'accessing' stamp: 'EstebanLorenzano 9/23/2011 17:08'!
codecNext: aGRCodecStream 
	^aGRCodecStream next! !

!GratuitousIncompatibilities class methodsFor: 'as yet unclassified' stamp: 'KentBeck 2/11/2010 17:56'!
compressLargeInteger: aLargeInteger
	^aLargeInteger normalize ! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'NorbertHartl 2/13/2012 17:27'!
dateAndTimeToMilliseconds: aDateAndTime
	^ (self dateToMilliseconds: aDateAndTime asDate) + aDateAndTime asTime asDuration asMilliseconds! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'EstebanLorenzano 10/6/2011 15:57'!
dateToMilliseconds: aDate 
	^(aDate - ((Date year: 1970 day: 0))) asDuration asMilliseconds! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'KentBeck 2/11/2010 18:05'!
doubleToBytes: aFloat
	| writer lowWord highWord |
	writer := LittleEndianStream on: (ByteArray new: 8) writeStream.
	lowWord := aFloat basicAt: 2.
	writer nextInt32Put: lowWord.
	highWord := aFloat basicAt: 1.
	writer nextInt32Put: highWord.
	^writer contents! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'KentBeck 2/11/2010 18:28'!
epoch
	^self newYear: 1970 day: 1! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'EstebanLorenzano 10/6/2011 17:47'!
intToDate: anInteger 
	^(self intToTime: anInteger) asDate - 1day! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'NorbertHartl 2/14/2012 12:02'!
intToDateAndTime: anInteger
	^(self intToTime: anInteger) ! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'NorbertHartl 2/14/2012 12:16'!
intToTime: anInteger 
	| sinceJavaEpoch |
	sinceJavaEpoch := Duration milliseconds: anInteger.
	^self epoch + sinceJavaEpoch! !

!GratuitousIncompatibilities class methodsFor: 'creation' stamp: 'NorbertHartl 2/14/2012 12:15'!
newYear: yearInteger day: dayInteger
	^DateAndTime year: yearInteger day: dayInteger hour: 0 minute: 0 second: 0 offset: Duration zero! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'KentBeck 2/11/2010 21:40'!
readDoubleFrom: aStream
	| reader result |
	result := Float new: 8.
	result basicAt: 2 put: aStream nextUInt32.
	result basicAt: 1 put: aStream nextUInt32.
	^result! !

!GratuitousIncompatibilities class methodsFor: 'creation' stamp: 'KentBeck 2/11/2010 22:48'!
socketStreamHost: aString port: anInteger 
	| result |
	result := SocketStream openConnectionToHostNamed: aString port: anInteger.
	result binary.
	^result! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'KentBeck 2/11/2010 18:27'!
timeToBytes: aDateAndTime 
	^aDateAndTime asDuration asMilliseconds - self epoch asDuration asMilliseconds! !

!GratuitousIncompatibilities class methodsFor: 'converting' stamp: 'KentBeck 2/12/2010 11:39'!
timeToMilliseconds: aDateAndTime 
	^aDateAndTime asDuration asMilliseconds ! !

!GratuitousIncompatibilities class methodsFor: 'creation' stamp: 'EstebanLorenzano 10/11/2011 22:44'!
utf8Codec
	^UTF8Codec ifNil: [ UTF8Codec := GRCodec forEncoding: 'utf8']! !

TestCase subclass: #MongoTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mongo-Squeak'!
